/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#define MAXN 15
#define MAXK 8

char dna[MAXN][MAXK+10];
bool done[1 << MAXN][MAXN];
double mem[1 << MAXN][MAXN];

int n, k, d;
double p;

double childprob(int i, int j) {
	double ret = 1;
	int h;
	for(h = 0; h < k; h++) {
		if(dna[i][h] == dna[j][h])
			ret *= (1 - p) + p * (1.0 / d);
		else
			ret *= p / d;
	}
	return ret;
}

double rec(int mask, int previous) {
	int i;
	if(mask == (1 << n) - 1)
		return 1;
	if(done[mask][previous])
		return mem[mask][previous];
	done[mask][previous] = true;
	mem[mask][previous] = 0;
	for(i = 0; i < n; i++) {
		if(mask & (1 << i))
			continue;
		mem[mask][previous] += childprob(i, previous) * rec(mask | (1 << i), i);
	}
	return mem[mask][previous];
}

void testcase() {
	int i;
	double sum;
	scanf("%d %d %d %lf\n", &n, &k, &d, &p);
	for(i = 0; i < n; i++)
		scanf("%s\n", dna[i]);
	memset(done, false, sizeof(done));
	sum = 0;
	for(i = 0; i < n; i++)
		sum += rec(1 << i, i);
	for(i = 0; i < n; i++)
		printf("%.6lf\n", rec(1 << i, i) / sum);
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
