//First draft of solution for: Evolution
//by Johan de Ruiter

#include <iostream>  
#include <sstream>  
#include <string>  
#include <vector>  
#include <queue>  
#include <set>  
#include <map>  
#include <cstdio>  
#include <cstdlib>  
#include <cctype>  
#include <cmath>  
#include <list>  
#include <numeric> 
#include <ctime>
#include <algorithm>
using namespace std;  
  
typedef vector<int> vi;  
typedef vector<vi> vvi;  
typedef vector<string> vs;  
typedef vector<vs> vvs; 
#define pb push_back  
#define sz(v) ((int)(v).size()) 

/*
We hebben N strings van lengte K. 
Een alfabet van grootte D.
Met kans P wordt een letter vervangen door een willekeurige andere letter (mogelijk zichzelf).

Gegeven is dat het een lineaire stamboom is.
Gevraagd is wat voor elke string de kans is dat hij de stamvader is.

Een string X en Y hebben A dezelfden en B anderen.

Kans dat een letter verandert in een specifieke ANDERE letter verandert:
  P/Sigma = Q
Kans dat een letter hetzelfde blijft (geen mutatie of mutatie naar zichzelf):
  1-P + Q = R

Stel resultaat dat je vindt is:

s1=0110
s2=1010
s3=1110
s4=0101

Matrix van veranderingen:
  
   s1 s2 s3 s4
s1  0  2  1  2
s2  2  0  1  4
s3  1  1  0  3
s4  2  4  3  0

N! Mogelijke stambomen

neem de som van de a priori kansen voor ieder en normaliseer (dat is eigenlijk bayes)
nu geimplementeerd met N! permutaties, dus N=15 is NIET haalbaar.
*/





int main()
{
  int i,j,k;
  char buf[100000];

  int run,runs;
  scanf("%d",&runs);
  for(run=0;run<runs;run++)
  {

    int N,K,Sigma;
    double P,Q,R;
    vs genen;
  
    scanf("%d %d %d %lf",&N,&K,&Sigma,&P);
    for(j=0;j<N;j++)
    {
      scanf("%s",buf); 
      genen.pb(buf);
    }
    
    Q=P/Sigma;
    R=1-P + Q;
    
    double Qmacht[10];
    double nQmacht[10];
    Qmacht[0]=nQmacht[0]=1;
    for(j=1;j<=K;j++)
    {
      Qmacht[j]=Qmacht[j-1]*Q;
      nQmacht[j]=nQmacht[j-1]*R;
    }
    
    
    vvi verschillen(N,vi(N,0));
    for(j=0;j<N;j++)
      for(i=j+1;i<N;i++)
      {
        for(k=0;k<K;k++)
          if(genen[j][k]!=genen[i][k])
            verschillen[j][i]++; 
        verschillen[i][j]=verschillen[j][i];
      }
  
    vector<double> odds(N,0);
  
    vi perm; for(j=0;j<N;j++) perm.pb(j);
    do
    {
      double prod=1;
      for(i=1;i<N;i++)
        prod*=Qmacht[verschillen[perm[i-1]][perm[i]]]*nQmacht[K-verschillen[perm[i-1]][perm[i]]];
      odds[perm[0]]+=prod;
    }while(next_permutation(perm.begin(),perm.end()));
  
    double totalsum=accumulate(odds.begin(),odds.end(),0.0);
  
    for(i=0;i<N;i++)
      printf("%lf\n",odds[i]/totalsum);
  }

  return 0;
}

