import java.text.*;
import java.io.* ;


public class evolution {

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	
	public static void main(String[] args) throws Exception {
		int n = readInt();
		long t = System.currentTimeMillis();
		for (int i=0;i<n;i++)
			doShizzle();
	}
	
	public static int readInt() throws Exception {
		return Integer.parseInt(in.readLine());
	}
	
	static double prob[][] = new double[15][15];
	static double memory[][] = new double[32768][15]; //memorizes probability for using creature, ending with last creature
	static boolean done[][] = new boolean[32768][15];
	static double sum;
	static int N;
	
	private static double calculate(int used, int last){
		if (done[used][last]) return memory[used][last];

		double res = 0;
		if (used==((1<<N)-1)) res = 1; else //end of tree
		for (int i=0; i<N; i++){            //add creature i
			if ((used&(1<<i))==0) {
				if (used==0) //the first has no previous creature
					res += calculate(used + (1<<i), i); else
					res += calculate(used + (1<<i), i)*prob[last][i];
			}
		};
		
		done[used][last] = true;
		memory[used][last] = res;
		return res;
	}
	
	private static void doShizzle() throws Exception {
		String readLine = in.readLine();
		String[] split = readLine.split(" ");
		N = Integer.parseInt(split[0]);
		int k = Integer.parseInt(split[1]);
		int d = Integer.parseInt(split[2]);
		double p = Double.parseDouble(split[3]);
		double q = p/d; //chance that a letter changes
                                //to a specific other letter
                double r = (1-p) + q;  // chance that a letter does not change
                                       // or changes to itself
		
		String[] creatures = new String[N];
		for (int i=0;i<N;i++)
			creatures[i] = in.readLine();

		for (int i=0;i<N;i++)
			for (int j=0;j<N;j++){
				int differ = 0;
				for (int l=0;l<k;l++)
					if (creatures[i].charAt(l)!=creatures[j].charAt(l)) differ ++;
				prob[i][j] = Math.pow(q, differ)*Math.pow(r, k-differ);
			}

		
		for (int i=0;i< (1<<N);i++)
			for (int j=0;j<15;j++)
				done[i][j] = false;

		sum = calculate(0, 0);

		DecimalFormat df = new DecimalFormat("0.000000");
	    DecimalFormatSymbols dfs = df.getDecimalFormatSymbols();
	    dfs.setDecimalSeparator('.');
	    df.setDecimalFormatSymbols(dfs);
		
		for (int i=0;i<N;i++){
			System.out.println(df.format(memory[(1<<i)][i]/sum));
		}

	}
}
