/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

bool cansplit(int a, int b, int c, int d) {
	return a == b + c + d || a + b == c + d || a + c == b + d || a + d == b + c || a + b + c == d || a + b + d == c || a + c + d == b;
}

int digs[10];

void countdigs(int i) {
	do {
		digs[i%10]++;
		i /= 10;
	} while(i);
}

void testcase() {
	int i, j, D, M, Y;
	scanf("%d %d %d\n", &D, &M, &Y);
	memset(digs, 0, sizeof(digs));
	countdigs(D);
	countdigs(M);
	countdigs(Y);
	for(i = 0; i < 10; i++) {
		for(j = 0; j < 10; j++) {
			if(digs[i] > 0 && digs[j] > 0 && digs[i] != digs[j]) {
				printf("no\n");
				return;
			}
		}
	}
	if(cansplit(D, M, Y / 100, Y % 100))
		printf("yes\n");
	else
		printf("no\n");
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
