/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define MAXN 10000

char input[MAXN+10];
int next1[26][MAXN+1];
int next2[26][26][MAXN+1];

void testcase() {
	int i, j, k, l, len, N;
	bool other;
	scanf("%s\n", &input);
	for(i = 0; input[i]; i++)
		input[i] -= 'A';
	len = i;
	for(i = 0; i < 26; i++) {
		next1[i][len] = -1;
		for(j = 0; j < 26; j++)
			next2[i][j][len] = -1;
	}
	other = false;
	for(i = len - 1; i >= 0; i--) {
		if(input[i] != input[0]) other = true;
		for(j = 0; j < 26; j++) {
			next1[j][i] = next1[j][i+1];
			for(k = 0; k < 26; k++)
				next2[j][k][i] = next2[j][k][i+1];
		}
		next1[input[i]][i] = i;
		if(i < len - 1)
			next2[input[i]][input[i+1]][i] = i;
	}
	// Iets van de vorm A..B..A is nooit uniek
	if(input[0] == input[len-1] && other) {
		printf("not unique\n");
		return;
	}
	for(i = 0; i < 26; i++) {
		for(j = 0; j < 26; j++) {
			for(k = 0; k < 26; k++) {
				if(k == j) continue;
				for(l = 0; l < 26; l++) {
					if(next2[i][j][0] == -1) continue;
					if(next1[l][next2[i][j][0]+1] == -1) continue;
					if(next2[i][k][next1[l][next2[i][j][0]+1]] == -1) continue;
					if(next1[l][next2[i][k][next1[l][next2[i][j][0]+1]]+1] == -1) continue;
					// Iets van de vorm ..AB..C..AD..C.. is nooit uniek
					// hierbij moet B != D, de rest kan gelijk zijn en B en C of D en C kunnen zelfs overlappen
					printf("not unique\n");
					return;
				}
			}
		}
	}
	// De rest is uniek
	printf("unique\n");
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
