import java.io.* ;

//Algorithm makes a graph (26 vertices) and looks if the Euler path is unique
//the path is not unique if some point has 2 outgoing edges which are not bridges.
//A bridge is an edge which would make the endpoint unreachable if deleted.
//The algorithm can run in O(26^3 + L), with L the length of the string. 
public class equal {

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	
	public static void main(String[] args) throws Exception {
		int n = readInt();
		long t = System.currentTimeMillis();
		for (int i=0;i<n;i++)
			doShizzle();
	}
	
	public static int readInt() throws Exception {
		return Integer.parseInt(in.readLine());
	}

	static int[][] pair = new int[26][26];
	static int[] number = new int[26];
	static int last;
	static boolean[] visited = new boolean[26];
	
	public static void visit(int i){
		visited[i] = true;
		for (int k=0;k<26;k++)
			if (!visited[k]&&pair[i][k]>0) visit(k);
	}
	
	public static boolean connected(int i){
		for (int k=0;k<26;k++) visited[k] = false;
		visit(i);
		return visited[last];
	}
	
	private static void doShizzle() throws Exception {
		String phrase = in.readLine();
		int l = phrase.length();
		last = phrase.charAt(l-1)-'A';
		for (int i=0; i<26;i++){
			number[i] = 0;
			for (int k=0;k<26;k++) pair[i][k] = 0;
		}
		boolean allcharactersequal = true;
		for (int i=0; i<l-1; i++){
			pair[phrase.charAt(i)-'A'][phrase.charAt(i+1)-'A']++;
			allcharactersequal = allcharactersequal && (phrase.charAt(i)-'A'==phrase.charAt(i+1)-'A');
			if (pair[phrase.charAt(i)-'A'][phrase.charAt(i+1)-'A']==1) number[phrase.charAt(i)-'A']++;
		}
		if ((phrase.charAt(0)==phrase.charAt(l-1))&& (!allcharactersequal)){
			System.out.println("not unique");
			return;
		}
		for (int i=0;i<26;i++)
			if (number[i]>1){
				int bridge = 0;
				for (int k=0;k<26;k++)
					if (pair[i][k]>0){ //is graph still 'connected' if the edge is deleted?
						pair[i][k]--;
						if (!connected(i)) bridge++;
						pair[i][k]++;
					}
				if (number[i]-bridge>1){
					System.out.println("not unique");
					return;
				}
			}
		System.out.println("unique"); 
	}
}
