/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 * O(N * log(N) * L)
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#define MAXN 1000
#define MAXL 30

char bad[MAXN][MAXL];
char good[MAXN][MAXL];

int N2;

bool matchGood(int i, int l) {
	int low = 0, high = N2 - 1, act;
	while(low < high) {
		act = (low + high) / 2;
		if(memcmp(bad[i], good[act], sizeof(char) * l) <= 0)
			high = act;
		else
			low = act + 1;
	}
	return memcmp(bad[i], good[low], sizeof(char) * l) == 0;
}

void testcase() {
	int i, j, l, N1, ret;
	scanf("%d\n", &N1);
	for(i = 0; i < N1; i++)
		scanf("%s\n", bad[i]);
	qsort(bad, N1, sizeof(bad[0]), strcmp);
	scanf("%d\n", &N2);
	for(i = 0; i < N2; i++)
		scanf("%s\n", good[i]);
	if(N2 == 0) {
		printf("1\n");
		return;
	}
	qsort(good, N2, sizeof(good[0]), strcmp);

	ret = 0;
	for(i = 0; i < N1; ret++) {
		l = 1;
		while(matchGood(i, l))
			l++;
		j = i + 1;
		while(j < N1 && memcmp(bad[i], bad[j], sizeof(char) * l) == 0)
			j++;
		i = j;
	}
	printf("%d\n", ret);
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
