/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define MAX(a, b) ((a) > (b) ? (a) : (b))
#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAXN 10000

int N;

struct Point {
	int x, y;
} scan1[MAXN], scan2[MAXN];

int compare_point(const struct Point *a, const struct Point *b) {
	if(a->x == b->x)
		return a->y - b->y;
	return a->x - b->x;
}

bool check() {
	int i, s1x, s1y, b1x, b1y, s2x, s2y, b2x, b2y;
	s1x = b1x = scan1[0].x;
	s1y = b1y = scan1[0].y;
	s2x = b2x = scan2[0].x;
	s2y = b2y = scan2[0].y;
	for(i = 1; i < N; i++) {
		s1x = MIN(s1x, scan1[i].x);
		b1x = MAX(b1x, scan1[i].x);
		s1y = MIN(s1y, scan1[i].y);
		b1y = MAX(b1y, scan1[i].y);
		s2x = MIN(s2x, scan2[i].x);
		b2x = MAX(b2x, scan2[i].x);
		s2y = MIN(s2y, scan2[i].y);
		b2y = MAX(b2y, scan2[i].y);
	}
	if((b2x - s2x) * (b1y - s1y) != (b2y - s2y) * (b1x - s1x))
		return false;
	for(i = 1; i < N; i++)
		if((scan1[i].x - scan1[0].x) * (b2x - s2x) != (scan2[i].x - scan2[0].x) * (b1x - s1x)
			|| (scan1[i].y - scan1[0].y) * (b2y - s2y) != (scan2[i].y - scan2[0].y) * (b1y - s1y))
			return false;
	return true;
}

void rotate1() {
	int i, j;
	for(i=0;i<N;i++) {
		j = scan1[i].x;
		scan1[i].x = scan1[i].y;
		scan1[i].y = -j;
	}
	qsort(scan1, N, sizeof(struct Point), compare_point);
}

void testcase() {
	int i;
	scanf("%d\n", &N);
	for(i=0;i<N;i++)
		scanf("%d %d\n", &scan1[i].x, &scan1[i].y);
	for(i=0;i<N;i++)
		scanf("%d %d\n", &scan2[i].x, &scan2[i].y);
	qsort(scan1, N, sizeof(struct Point), compare_point);
	qsort(scan2, N, sizeof(struct Point), compare_point);
	for(i=0;i<4;i++) {
		if(i>0)
			rotate1();
		if(check()) {
			printf("okay\n");
			return;
		}
	}
	printf("mismatch!\n");
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
