#include <iostream> 
#include <sstream> 
#include <string> 
#include <vector> 
#include <queue> 
#include <set> 
#include <map> 
#include <cstdio> 
#include <cstdlib> 
#include <cctype> 
#include <cmath> 
#include <list> 
#include <numeric>
using namespace std; 
 
typedef vector<int> vi; 
typedef vector<vi> vvi; 
typedef vector<string> vs; 
typedef vector<vs> vvs;
typedef pair<int,int> pii;
typedef set<pii> spii;
#define pb push_back 
#define sz(v) ((int)(v).size())


void print(spii in)
{
  printf("-----------\n");
  for(spii::iterator I=in.begin();I!=in.end();I++)
    printf("(%d,%d)\n",I->first,I->second);

}


spii roteer(spii in)
{
//printf("in roteer\n");
  spii out;
  pii p;
  for(spii::iterator I=in.begin();I!=in.end();I++)
  {
    p=*I;
    swap(p.first,p.second);
    p.first*=-1;
    out.insert(p);
  }
//printf("uit roteer\n");
  return out;
}


spii normalize(spii in)
{
//  printf("in normalize\n");
  spii out;
  pii p;
  int fmin=1000000,smin=1000000;
  for(spii::iterator I=in.begin();I!=in.end();I++)
  {
    fmin=min(fmin,I->first);
    smin=min(smin,I->second);
  }
  for(spii::iterator I=in.begin();I!=in.end();I++)
  {
    p=*I;
    p.first-=fmin;
    p.second-=smin;
    out.insert(p);
  }  
//  printf("uit normalize\n");
  return out;
}


int ggd(int a, int b)
{
  if(b==0)
    return a;
  return ggd(b,a%b);
}


bool congruent(spii A, spii B)
{
//  printf("in congruent\n");
  int Afmax=1,Bfmax=1;
  for(spii::iterator I=A.begin();I!=A.end();I++)
    Afmax=max(Afmax,I->first);
  for(spii::iterator I=B.begin();I!=B.end();I++)
    Bfmax=max(Bfmax,I->first);
  int kgv=(Afmax*Bfmax)/ggd(Afmax,Bfmax);

  spii _A,_B;
  for(spii::iterator I=A.begin();I!=A.end();I++)
  {
    pii p=*I;
    p.first*=kgv/Afmax;
    p.second*=kgv/Afmax;
    _A.insert(p);
  }
  for(spii::iterator I=B.begin();I!=B.end();I++)
  {
    pii p=*I;
    p.first*=kgv/Bfmax;
    p.second*=kgv/Bfmax;
    _B.insert(p);
  }

//print(_A);
//print(_B);
//  printf("uit congruent\n");
  return _A==_B;
}


int main()
{
  int i,j,k;
  int run,runs;
  scanf("%d",&runs);
  for(run=0;run<runs;run++)
  {
    int N;
    scanf("%d",&N);

    spii S[2];
    pii p;
    for(j=0;j<2*N;j++)
    {
      scanf("%d %d",&p.first,&p.second);
      S[j/N].insert(p);
    }
    S[0]=normalize(S[0]);

    bool equal=false;

    for(i=0;i<4;i++)
    {
      S[1]=normalize(roteer(S[1]));
      if(congruent(S[0],S[1]))
        equal=true;
    }

    if(equal) printf("okay\n");
    else printf("mismatch!\n");
  }

  return 0;
}
