import java.util.*;
import java.io.*;
import java.awt.geom.*;
import java.text.*;

public class farmerjohn_jb_java {
   public static DecimalFormat fm = new DecimalFormat("0.000000", new DecimalFormatSymbols(Locale.US));
   
   public static void main(String[] args) {
      Scanner sc = new Scanner(System.in);
      int tests = sc.nextInt();
      while(tests-- > 0) {
         int Bx = sc.nextInt();
         int By = sc.nextInt();
         int Fx = sc.nextInt();
         int Fy = sc.nextInt();
         int N = sc.nextInt();
         int M = N*2+2;
         Line2D[] fences = new Line2D[N];
         Point2D[] points = new Point2D[M];
         for(int i = 0; i < N; i++) {
            int x1 = sc.nextInt();
            int y1 = sc.nextInt();
            int x2 = sc.nextInt();
            int y2 = sc.nextInt();
            points[i*2] = new Point2D.Double(x1, y1);
            points[i*2+1] = new Point2D.Double(x2, y2);
            fences[i] = new Line2D.Double(points[i*2], points[i*2+1]);
         }
         points[N*2] = new Point2D.Double(Bx, By);
         points[N*2+1] = new Point2D.Double(Fx, Fy);
         boolean[][] conn = new boolean[M][M];
         double[][] dist = new double[M][M];
         for(int i = 0; i < M; i++) {
            for(int j = i+1; j < M; j++) {
               conn[i][j] = true;
               dist[i][j] = points[i].distance(points[j]);
               Line2D line = new Line2D.Double(points[i], points[j]);
               for(int k = 0; k < N; k++) {
                  if(fences[k].getP1().equals(points[i]) || fences[k].getP2().equals(points[i]) || fences[k].getP1().equals(points[j]) || fences[k].getP2().equals(points[j]))
                     continue;
                  if(line.intersectsLine(fences[k])) {
                     conn[i][j] = false;
                     break;
                  }
               }
               conn[j][i] = conn[i][j];
               dist[j][i] = dist[i][j];
            }
         }
         for(int i = 0; i < M; i++) {
            for(int j = 0; j < M; j++) {
               for(int k = 0; k < M; k++) {
                  if(conn[j][i] && conn[i][k]) {
                     double newDist = dist[j][i] + dist[i][k];
                     if(!conn[j][k] || newDist < dist[j][k]) {
                        conn[j][k] = true;
                        dist[j][k] = newDist;
                     }
                  }
               }
            }
         }
         if(!conn[N*2][N*2+1])
            System.out.println("-1");
         else
            System.out.println(fm.format(dist[N*2][N*2+1]));
      }
   }
}