/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXX 1024
#define MAXY 1024

int BIT[MAXX+1][MAXY+1];

int readupto(int x, int y) {
    int yt, ret = 0;
    while(x > 0) {
		yt = y;
		while(yt > 0) {
	        ret += BIT[x][yt];
			yt -= (yt & -yt);
		}
        x -= (x & -x);
    }
    return ret;
}

int readRectangle(int x1, int y1, int x2, int y2) {
	int ret = readupto(x2, y2);
	if(x1 > 1)
		ret -= readupto(x1 - 1, y2);
	if(y1 > 1)
		ret -= readupto(x2, y1 - 1);
	if(x1 > 1 && y1 > 1)
		ret += readupto(x1 - 1, y1 - 1);
	return ret;
}

void addval(int x, int y, int val) {
	int yt;
    while(x <= MAXX) {
		yt = y;
		while(yt <= MAXY) {
	        BIT[x][yt] += val;
			yt += (yt & -yt);
		}
		x += (x & -x);
    }
}

int main() {
	int t, x, y, x2, y2, n;
	char c;
	for(x = 1; x <= 1024; x++)
		for(y = 1; y <= 1024; y++)
			if((x % 2) == (y % 2))
				addval(x, y, 1);
	scanf("%d\n", &t);
	while(t--) {
		c = getchar();
		if(c == 'R') {
			scanf(" %d %d %d %d\n", &x, &y, &x2, &y2);
			n = readRectangle(x, y, x2, y2);
			printf("%d %d\n", n, (x2 - x + 1) * (y2 - y + 1) - n);
		} else {
			scanf(" %d %d\n", &x, &y);
			n = readRectangle(x, y, x, y);
			if((n == 0 && c == 'A') || (n == 1 && c == 'B'))
				addval(x, y, c == 'A' ? 1 : -1);
		}
	}
	return 0;
}
