/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#define MAXN 100000

int father[MAXN+1];
int mother[MAXN+1];
bool done[MAXN+1];
int mem[MAXN+1];

int B0;

int rec(int a) {
	if(done[a])
		return mem[a];
	done[a] = true;
	mem[a] = -1;
	if(father[a] == B0 || mother[a] == B0)
		return mem[a] = 0;
	if(father[a] != 0 && rec(father[a]) != -1 && (mem[a] == -1 || rec(father[a]) < mem[a]))
		mem[a] = rec(father[a]);
	if(mother[a] != 0 && rec(mother[a]) != -1 && (mem[a] == -1 || rec(mother[a]) + 1 < mem[a]))
		mem[a] = rec(mother[a]) + 1;
	return mem[a];
}

void testcase() {
	int N, A0, b, c, i;
	scanf("%d\n", &N);
	scanf("%d %d\n", &A0, &B0);
	for(i=0;i<N;i++) {
		scanf("%d %d\n", &b, &c);
		father[i+1] = b;
		mother[i+1] = c;
	}
	memset(done, false, sizeof(done));
	if(rec(A0) == -1)
		printf("no ancestor\n");
	else
		printf("%d\n", rec(A0));
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
